#ifndef MAXVERBOSE
#define MAXVERBOSE 3
#endif

OPT(alluip,2,0,2,"all UIP learning 1=unary, 2=binary")
OPT(arena,2,0,2,"allocate clauses(1) and watches(2) in arena")
OPT(bcdlinear,1,0,1,"try BCD in linear order of clauses")
OPT(bcdpurelinear,1,0,1,"try first pure then linear BCD")
OPT(bcdinverse,0,0,1,"try BCD in inverse linear order of clauses")
OPT(bcdpureinverse,1,0,1,"try first pure then inverse BCD")
OPT(block,1,0,1,"blocked clause elimination (BCE)")
OPT(block1lim,10000,0,INT_MAX,"one sided BCE ocurrence limit")
OPT(block2lim,100000,0,INT_MAX,"two sided BCE occurrence limit")
OPT(blockmove,1,0,1,"make blocked clauses redundant")
OPT(blockmovesize,3,2,INT_MAX,"size of moved blocked clauses")
#ifdef EXPENSIVECHECKS
OPT(check,0,0,1,"enable expensive checking at run-time")
#endif
OPT(clim,-1,-1,INT_MAX,"conflict limit")
OPT(deco,1,0,1,"learn decision only clauses")
OPT(decoglue,40,2,INT_MAX,"minimum glue for learning decision only clauses")
OPT(decolim,80,0,100,"total limit for considering decision only clause")
OPT(decompose,1,0,1,"decompose into strongly connected components")
#ifdef DRUPLIG
OPT(druplig,1,0,1,"connect to DRUPLIG library")
OPT(drupligcheck,1,0,1,"forward check learned clauses with DRUPLIG library")
OPT(drupligtrace,0,0,1,"trace learned clauses through DRUPLIG library")
OPT(drupligtraceorig,0,0,1,"trace original clauses too")
#endif
OPT(elim,1,0,1,"bounded variable elimination (BVE)")
OPT(elim1lim,100,0,INT_MAX,"one sided BVE ocurrence limit")
OPT(elim2lim,1000,0,INT_MAX,"two sided BVE occurrence limit")
OPT(elimclslim,1000,0,INT_MAX,"maximal clause length in elimination")
OPT(elimrounds,3,1,100,"maximum elimination rounds")
OPT(gluefastema,5,0,31,"alpha=2^-e fast glue EMA (restart force)")
OPT(glueslowema,16,0,31,"alpha=2^-e slow glue EMA (restart force)")
OPT(hbr,1,0,1,"hyper binary resolution on decision level 1")
OPT(hbrlim,1,0,1,"limit hyper binary resolution")
OPT(inprocessing,1,0,1,"enable inprocessing")
OPT(jumpema,20,0,31,"alpha=2^-e jump level EMA (restart delay)")
OPT(keep,2,2,20,"keep 1=unary, 2=binary, 3=ternaryi,... learned clauses")
#ifdef LOGGING
OPT(log,0,0,1,"enable logging at run-time")
#endif
OPT(maxpen,3,0,20,"maximum logarithm of penalty")
OPT(minimize,1,0,1,"minimize learned clauses")
OPT(otfs,1,0,1,"enable on-the-fly subsumption")
OPT(probe,1,0,1,"failed literal probing")
OPT(probewait,1,0,INT_MAX,"wait until that inprocessing round")
OPT(probeproplim,100,0,10000,"max fraction props in permille")
OPT(probepropminlim,100000,0,INT_MAX,"minimum propagations")
OPT(profile,2,0,4,"profiling level")
OPT(queuestamplim,31,0,31,"log queue stamp limit for fuzzing and testing")
OPT(reduce,1,0,1,"enable clause reduction")
OPT(reduceinc,100,1,INT_MAX,"reduce limit increment")
OPT(reduceinit,2000,1,INT_MAX,"initial reduce limit")
OPT(resolvedsizema,20,1,31,"resolved clause size ema")
OPT(resolvedlim,31,1,31,"resolved limit for fuzzing and testing")
OPT(resolvedgluema,20,1,31,"resolved clause size ema")
OPT(restart,1,0,1,"enable restarting")
OPT(restartdelay,1,0,1,"enable restart delaying")
OPT(restartdelaybound,100000,0,INT_MAX,"delay restart lower bound")
OPT(restartdelaylim,50,10,100,"restart fast/slow level EMA limit")
OPT(restartforce,1,0,1,"enable Glucose style restart forcing")
OPT(restartforcelim,110,100,200,"restart fast/slow glue EMA limit")
OPT(restartint,10,1,INT_MAX,"base restart interval")
OPT(reusetrail,1,0,1,"reuse trail during restarting")
OPT(seed,0,INT_MIN,INT_MAX,"random seed")
OPT(simplify,1,0,1,"enable simplification")
OPT(simplifyincsoft,100000,100,INT_MAX,"soft simp interval limit")
OPT(simplifyinchard,1000000,1000,INT_MAX,"hard simp interval limit")
OPT(simplifyint,20000,1,INT_MAX,"initial simplification interval")
OPT(simplifyinit,200,0,INT_MAX,"initial simplification conflict limit")
OPT(simplifybinlimfactor,10,1,1000,"increment simplification binary limit")
OPT(simplifybinliminit,1000,1,INT_MAX,"initial simplification binary limit")
OPT(simplifyitlimfactor,10,1,1000,"increment simplification iteration limit")
OPT(simplifyitliminit,100,1,INT_MAX,"initial simplification iteration limit")
OPT(simplifyminint,2000,1,INT_MAX,"minimum simplification interval")
OPT(subsume,1,0,1,"subsume all clauses")
OPT(subsumechecklim,200,0,10000,"max fraction subsume all checks in permille")
OPT(subsumecheckminlim,1000000,0,INT_MAX,"minimum absolute limit")
OPT(subsumeint,20000,1,INT_MAX,"subsume all clauses conflict interval")
OPT(subsumeinc,10000,1,INT_MAX,"subsume all clauses interval increment")
OPT(subsumeclslim,10000,0,INT_MAX,"max clause size limit")
OPT(subsumeocclim,10000,0,INT_MAX,"max occurrence limit")
OPT(subsumerecent,3,0,100,"subsume recent learned clauses")
OPT(sweep,1,0,1,"blocked clause decomposition (BCD) based sweeping")
OPT(sweepconflim,100,0,INT_MAX,"local sweep solving conflict limit")
OPT(sweeprand,5,1,100,"random models to initialize sweeping")
OPT(sweepwait,0,0,INT_MAX,"wait until this simplification")
OPT(trace,0,0,1,"print DRUP/DRAT clausal proof trace")
OPT(trailfastema,12,0,31,"fast trail EMA (restart blocking)")
OPT(trailslowema,20,0,31,"slow trail EMA (reporting only)")
OPT(verbose,0,0,MAXVERBOSE,"verbosity level")
